//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: evmos/vesting/v1/tx.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Msg defines the bank Msg service.
///
/// Usage: instantiate `Evmos_Vesting_V1_MsgClient`, then call methods of this protocol to make API calls.
internal protocol Evmos_Vesting_V1_MsgClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Evmos_Vesting_V1_MsgClientInterceptorFactoryProtocol? { get }

  func createClawbackVestingAccount(
    _ request: Evmos_Vesting_V1_MsgCreateClawbackVestingAccount,
    callOptions: CallOptions?
  ) -> UnaryCall<Evmos_Vesting_V1_MsgCreateClawbackVestingAccount, Evmos_Vesting_V1_MsgCreateClawbackVestingAccountResponse>

  func clawback(
    _ request: Evmos_Vesting_V1_MsgClawback,
    callOptions: CallOptions?
  ) -> UnaryCall<Evmos_Vesting_V1_MsgClawback, Evmos_Vesting_V1_MsgClawbackResponse>
}

extension Evmos_Vesting_V1_MsgClientProtocol {
  internal var serviceName: String {
    return "evmos.vesting.v1.Msg"
  }

  /// CreateClawbackVestingAccount defines a method that enables creating a
  /// vesting account that is subject to clawback.
  ///
  /// - Parameters:
  ///   - request: Request to send to CreateClawbackVestingAccount.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func createClawbackVestingAccount(
    _ request: Evmos_Vesting_V1_MsgCreateClawbackVestingAccount,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Evmos_Vesting_V1_MsgCreateClawbackVestingAccount, Evmos_Vesting_V1_MsgCreateClawbackVestingAccountResponse> {
    return self.makeUnaryCall(
      path: "/evmos.vesting.v1.Msg/CreateClawbackVestingAccount",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeCreateClawbackVestingAccountInterceptors() ?? []
    )
  }

  /// Clawback removes the unvested tokens from a ClawbackVestingAccount.
  ///
  /// - Parameters:
  ///   - request: Request to send to Clawback.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func clawback(
    _ request: Evmos_Vesting_V1_MsgClawback,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Evmos_Vesting_V1_MsgClawback, Evmos_Vesting_V1_MsgClawbackResponse> {
    return self.makeUnaryCall(
      path: "/evmos.vesting.v1.Msg/Clawback",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeClawbackInterceptors() ?? []
    )
  }
}

internal protocol Evmos_Vesting_V1_MsgClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'createClawbackVestingAccount'.
  func makeCreateClawbackVestingAccountInterceptors() -> [ClientInterceptor<Evmos_Vesting_V1_MsgCreateClawbackVestingAccount, Evmos_Vesting_V1_MsgCreateClawbackVestingAccountResponse>]

  /// - Returns: Interceptors to use when invoking 'clawback'.
  func makeClawbackInterceptors() -> [ClientInterceptor<Evmos_Vesting_V1_MsgClawback, Evmos_Vesting_V1_MsgClawbackResponse>]
}

internal final class Evmos_Vesting_V1_MsgClient: Evmos_Vesting_V1_MsgClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Evmos_Vesting_V1_MsgClientInterceptorFactoryProtocol?

  /// Creates a client for the evmos.vesting.v1.Msg service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Evmos_Vesting_V1_MsgClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Msg defines the bank Msg service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Evmos_Vesting_V1_MsgProvider: CallHandlerProvider {
  var interceptors: Evmos_Vesting_V1_MsgServerInterceptorFactoryProtocol? { get }

  /// CreateClawbackVestingAccount defines a method that enables creating a
  /// vesting account that is subject to clawback.
  func createClawbackVestingAccount(request: Evmos_Vesting_V1_MsgCreateClawbackVestingAccount, context: StatusOnlyCallContext) -> EventLoopFuture<Evmos_Vesting_V1_MsgCreateClawbackVestingAccountResponse>

  /// Clawback removes the unvested tokens from a ClawbackVestingAccount.
  func clawback(request: Evmos_Vesting_V1_MsgClawback, context: StatusOnlyCallContext) -> EventLoopFuture<Evmos_Vesting_V1_MsgClawbackResponse>
}

extension Evmos_Vesting_V1_MsgProvider {
  internal var serviceName: Substring { return "evmos.vesting.v1.Msg" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "CreateClawbackVestingAccount":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Evmos_Vesting_V1_MsgCreateClawbackVestingAccount>(),
        responseSerializer: ProtobufSerializer<Evmos_Vesting_V1_MsgCreateClawbackVestingAccountResponse>(),
        interceptors: self.interceptors?.makeCreateClawbackVestingAccountInterceptors() ?? [],
        userFunction: self.createClawbackVestingAccount(request:context:)
      )

    case "Clawback":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Evmos_Vesting_V1_MsgClawback>(),
        responseSerializer: ProtobufSerializer<Evmos_Vesting_V1_MsgClawbackResponse>(),
        interceptors: self.interceptors?.makeClawbackInterceptors() ?? [],
        userFunction: self.clawback(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Evmos_Vesting_V1_MsgServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'createClawbackVestingAccount'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeCreateClawbackVestingAccountInterceptors() -> [ServerInterceptor<Evmos_Vesting_V1_MsgCreateClawbackVestingAccount, Evmos_Vesting_V1_MsgCreateClawbackVestingAccountResponse>]

  /// - Returns: Interceptors to use when handling 'clawback'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeClawbackInterceptors() -> [ServerInterceptor<Evmos_Vesting_V1_MsgClawback, Evmos_Vesting_V1_MsgClawbackResponse>]
}
